C                ********
C                 PAWCELL
C
C PROGRAM BY G.S.PAWLEY
C MODIFIED AT SEVERAL OCCASIONS, MOST RECENTLY JAN 86, BY M.S.LEHMANN
C AN ATTEMPT HAS BEEN MADE TO KEEP THE ORIGINAL GSP FLAVOR, BOTH IN
C PROGRAMMING STYLE AND OUTPUT LAYOUT
C HASYLAB VERSION. ASSUMES TO KNOW BOTH ANGLE AND COUNT
C FAKES STEP WHEN NESCESSARY
C MODIFIED FOR THE VOIGT FOUNCTION
C GAMMA REPLACES SKEWNESS (9)
C EXPRESSIONS AS IN PAPER BY DAVID AND MATTHEWMAN (J.APPL.C. 18,461)
C AND REFERENCES THEREIN
C MODIFIED TO READ DIFFERENT FORMATS AND TO OUTPUT ANOTHER REFLEXION
C FILE. JUAN RODRIGUEZ (OCT-1986)
C MODIFIED TO BE USED IN SEQUENTIAL REFINEMENTS. JUAN RODRIGUEZ (JUNE-87)
C
C THE FILES ARE
C UNIT 2 INPUT OF CONTROL FLAG'S OF EACH CYCLE 
C UNIT 5 INPUT CONTROL DATA
C UNIT 7 PROFILE DATA ON OUTPUT FOR PLOTTING
C UNIT 9 NEW INPUT DATA AFTER LAST CYCLE
C UNIT 10 IS LINE PRINTER OUTPUT
C UNIT 14 SUMMARY OF FITTED PARAMETERS AND STANDARD DEVIATIONS ON LAST
C         CYCLE.
C UNIT 37 F'S IN SHELX FORMAT
C UNIT 38 F'S IN X-RAY FORMAT
C UNIT 39 NEW BACKGOUND FUNCTION PROPOSED
C UNIT 41 INPUT BACKGOUND VALUES
C UNIT 42 PROFILE INPUT DATA
C**************************** MAIN PROGRAM *****************************
C MAXIMUM 14100 LESS 2 BLOCKS = 14000 POINTS IN THE SCAN
C MAXIMUM 321 PARAMETERS VARIABLE  THEREFORE AM(321*320/2)
C MAXIMUM 515 PARAMETERS
C MAXIMUM 1500 REFLECTIONS
C MAXIMUM 41 POINTS PER REFLECTION, HALFWIDTH 20
C BLOCKSIZE 2 OF 50 = 100
      COMMON IOI,IOO,AM(51360),V(321),DEGRAD,RCP(6),DCELL(6,6),AT(3,3),
     1 ZT(3,3),IRHOMB,LATTIS,MINRH,MAXRH,NPEAKS,NBG,NDX(5,515),STEP,
     2 WISE(14100,4),MINPT,MAXPT,PTMIN,PTMAX,RMAX,ISCREW(3),IGLIDE(3),
     3 NREFS,IC,NC,NV,NVM,NP,NM,ISTOP,KEY,NREFL,TWOPIS,KEYREF(515),
     4 P(515),KI(515),PWISE(9),H(3),RHO,NOUT,NPM,MINPTU,MAXPTU,
     5 TWOPI,YC,WAVETC,DC(515),YSUM,YMASK,YAV,NMAX,NEXT,NSIDE,IW,
     6 KEYSUM,MSTEPU,SNTL(515),IDX(5,1500),LVAR(321),NO,KOUT,
     7 SLACK(10),SIG,REFSIG,LOT,K15,NPK,IVAR,KVAR(13,15),
     8 ION,MARKP(14100),YOBS(8600),WT(8600)
      COMMON/VOLUM/VCELL
      DIMENSION DWISE(100,321),DIFFAC(6),HJ(3),HK(3),SINS(515),
     1 CLOR(515),INDIC(515),INDT(5),TITLE(20)
      DIMENSION INTENS(10,3)
      REAL*8 REW,RIM,XV,YV
   17 FORMAT(1X,3I3,I4,2I6,26X,F13.2)
   18 FORMAT(20X,I6,26X,F13.5)
   19 FORMAT(1X,3I3,I4,2I6,4F13.2,4F9.2)
   20 FORMAT(' NUMBER OF VARIABLES THIS CYCLE IS',I4,I8,' REFLECTIONS')
   21 FORMAT(/' '47X'NUMERATOR'9X'DENOMINATOR'5X'R')
   22 FORMAT(' R FACTOR INCLUDING ZEROS',17X,F15.3,4X,F15.3,4X,F5.3)
   24 FORMAT(10F12.1)
   25 FORMAT(2F8.3,I8,2F8.5,I8,8A4)
   26 FORMAT(' AGREEMENT FACTORS BASED ON PARAMETERS BEFORE CYCLE'I3/' S
     1UM(W*(O-C)**2) IS'E11.3/' SQRT(SUM(W*(0-C)**2)/(NO-NV)) IS'F10.4)
   27 FORMAT(' ESTIMATED FACTORS BASED ON PARAMETERS AFTER  CYCLE'I3/' S
     1UM(W*(O-C)**2) IS'E11.3/' SQRT(SUM(W*(0-C)**2)/(NO-NV)) IS'F10.4)
   28 FORMAT(' MATRIX HAS A ZERO DIAGONAL ELEMENT CORRESPONDING TO PARAM
     1ETER'I3,' OF THOSE VARIED')
   29 FORMAT(//20(' + + +')/' PARAMETERS AFTER LEAST SQUARES CYCLE'I3/'
     1 INDICES'12X'PARAM'9X'OLD'8X'CHANGE'9X'NEW'9X'ERROR'3X'RATIO NEW E
     2RROR  2*THETA  LORENTZ')
   30 FORMAT(20X,I6,4F13.5,2F9.2)
   31 FORMAT(' CORRELATION MATRIX')
   32 FORMAT(' 'I3,10F9.4/(' '3X,10F9.4))
   33 FORMAT(' REFLECTIONS REORDERED',I4)
   34 FORMAT(' REDUCED SCAN VALUES ARE',2I7,' USING A STEP OF',F9.5)
   35 FORMAT(' MIN. AND MAX. 2-THETA TO BE USED',2F8.2,/' WAVELENGTH'
     1,F12.4)
   36 FORMAT(' LIMITING SPHERE REACHED',I6,' REFLECTIONS USED')
   37 FORMAT(' MEAN F.W.H.H. ='I4/' EQUIVALENT NUMBER OF REFLECTIONS ='I
     14/' NEW SQSIG ='F10.4)
   38 FORMAT(' MINIMUM AND MAXIMUM POINTS IN SCAN TO BE USED ARE',2I7)
   40 FORMAT(20A4)
   42 FORMAT(' PAWSYN: G.S. PAWLEYS PROGRAM FOR INTENSITY EXTRACTION.'
     1' (J. APPL. CRYST. 14 (1981) 357)'/
     2'  ---> MODIFIED FOR SYNCHROTRON DATA WITH VOIGTIAN PEAK-SHAPE'
     3/'  ---> DATA IS NOW BOTH 2THETA AND COUNTS',/
     4' PRESENT DATA IS:',20A4)
   45 FORMAT(' R FACTOR FOR PEAKS ONLY ',17X,F15.3,4X,F15.3,4X,F5.3)
   46 FORMAT(/' FIRST AND LAST ANGLE GIVEN ',2F8.3,
     1' NO. OF INPUT PEAK VALUES',I5,' STEP AND LAMBDA',F8.5,F8.3)
   47 FORMAT(' POSITION OF ARRAY OUT OF ORDER')
      IOI = 5
      IOO = 10
      OPEN(UNIT=7,STATUS='NEW',FORM='FORMATTED')
      OPEN(UNIT=9,STATUS='NEW',FORM='FORMATTED')
      OPEN(UNIT=37,STATUS='NEW',FORM='FORMATTED')
      OPEN(UNIT=38,STATUS='NEW',FORM='FORMATTED')
      IOP = 7
      ION = 9
      IOF = 37
      IOX = 38
      K15=15
      NVM=321
C
C  SET LOT=1 TO REFINE ALWAYS THE INTENSITIES
C
      LOT=1
      NTOT=(NVM*(NVM+1))/2
      NPM=515
      NATOM=40
      NREFS=1500
C      NWIDE=15
C  CHANGE FOR HIGH RESOLUTION HASYLAB DATA
      IVAR=0
      NWIDE=20
      KBL=50
      KBLKBL=2*KBL
      NMAX=14100-KBLKBL
      KTEST=KBLKBL-NWIDE
      PI=3.1415926
      TWOPIS=2.0*PI**2
C SQRT OF 2 PI
      TWPIRT=2.506628
      SQRTWO=1.414214
      SQRTPI=SQRT(PI)
      TWSQTW=2.828427
      CONFW=2.354820
      TWOPI=2.0*PI
      DEGRAD=PI/180.
      GAUSS=2.7726
      CONMEW=1.253314137
      YMASK=-4095.
      INDIC(1)=1
      DO 1001 I = 2,NPM
      K=2
      IF(I.GT.5)  K=3
      IF(I.GT.9)  K=2
      IF(I.GT.K15) K=6
 1001 INDIC(I)=K
C THIS IS NOW GAMMA, NOT SKEWNESS
      INDIC(9)=1
      NEXT=0
      READ(IOI,40) TITLE
      WRITE(IOO,42) TITLE
      WRITE(ION,40) TITLE
      READ(IOI,*)  ANMI,ANMA,NPEAKS,STEP,WAVETC,ITYPE
      WRITE(IOO,46) ANMI,ANMA,NPEAKS,STEP,WAVETC
      WRITE(ION,25) ANMI,ANMA,NPEAKS,STEP,WAVETC,ITYPE
      READ(IOI,*)  PTMIN,PTMAX,MSTEPU
      WRITE(ION,25) PTMIN,PTMAX,MSTEPU
      MINPT=ANMI/STEP
      MAXPT=ANMA/STEP
      MINPTU=PTMIN/STEP
      MAXPTU=PTMAX/STEP
      K=MINPTU/MSTEPU
      K=K*MSTEPU
      IF(K.NE.MINPTU) MINPTU=MSTEPU+K
      K=MAXPTU/MSTEPU
      MAXPTU=K*MSTEPU
      WRITE(IOO,38) MINPTU,MAXPTU
      MINPTU=MINPTU/MSTEPU
      MAXPTU=MAXPTU/MSTEPU
      STEP=STEP*FLOAT(MSTEPU)
      WRITE(IOO,34) MINPTU,MAXPTU,STEP
      PTMIN=FLOAT(MINPTU)*STEP
      PTMAX=FLOAT(MAXPTU)*STEP
C     THE LIMITS ARE SET 10 PERCENT TOO WIDE TO ALLOW FOR REFINEMENT
      MINRH= 9000.*(SIN(PTMIN*DEGRAD*0.5)/WAVETC)**2
      RMAX=         SIN(PTMAX*DEGRAD*0.5)/WAVETC
      MAXRH=10600.*RMAX**2
      CALL PRELIM(ITYPE)
      WRITE(IOO,35) PTMIN,PTMAX,WAVETC
      IF(NREFS.EQ.-1) CALL FINISH(6)
      IF(NC.EQ.0) NC=1
      DO 1051 IC = 1,NC
      DO 1002 I=1,NTOT
 1002 AM(I)=0.0
      DO 1004 I=1,NVM
      DO 1003 J = 1,KBLKBL
 1003 DWISE(J,I)=0.0
 1004 V(I)=0.0
      DO 1005 I = 1,NMAX
      MARKP(I)=0
 1005 WISE(I,2)=0.0
      MEANWD=0
      NBLOCK=0
      BLOCK=0.0
      RPNUM=0.0
      RPDEN=0.0
      RZNUM=0.0
      SIG=0.0
      IQUERY=0
      ISWAP=0
C     REORDER REFLECTIONS USING CURRENT CELL
      DO 1011 NREFL = 1,NPEAKS
      HK(1)=NDX(1,NREFL)
      HK(2)=NDX(2,NREFL)
      HK(3)=NDX(3,NREFL)
      HJ(1)=ZT(1,1)*HK(1)+ZT(2,1)*HK(2)+ZT(3,1)*HK(3)
      HJ(2)=ZT(1,2)*HK(1)+ZT(2,2)*HK(2)+ZT(3,2)*HK(3)
      HJ(3)=ZT(1,3)*HK(1)+ZT(2,3)*HK(2)+ZT(3,3)*HK(3)
      S=0.25*(HJ(1)**2+HJ(2)**2+HJ(3)**2)
      SNTL(NREFL)=SQRT(S)
      NDX(5,NREFL)=2.0* ASIN(SNTL(NREFL)*WAVETC)/(DEGRAD*STEP)
      IF(LOT.EQ.0) GO TO 1011
      IF(NREFL.EQ.1) GO TO 1011
      INDX=NDX(5,NREFL)
      K=NREFL
      J=0
      DO 1006 I = 1,20
      IF(K.EQ.1) GO TO 1007
      K=K-1
      IF(INDX.GE.NDX(5,K)) GO TO 1007
 1006 J=J+1
 1007 IF(J.EQ.0) GO TO 1011
      ISWAP=ISWAP+1
      S=SNTL(NREFL)
      T=P(NREFL+K15)
      DO 1008 I = 1,5
 1008 INDT(I)=NDX(I,NREFL)
      DO 1009 I = 1,J
      K=NREFL-I
      L=K+1
      SNTL(L)=SNTL(K)
      P(L+K15)=P(K+K15)
      DO 1009 M = 1,5
 1009 NDX(M,L)=NDX(M,K)
      SNTL(K)=S
      P(K+K15)=T
      DO 1010 I = 1,5
 1010 NDX(I,K)=INDT(I)
 1011 CONTINUE
      IF(ISWAP.NE.0) WRITE(IOO,33) ISWAP
C     SET UP FOR VARYING THE LOT
      IF(LOT.EQ.0) GO TO 1020
      M=KEYSUM
      DO 1016 NREFL = 1,NPEAKS
      N=NREFL+K15
      NDX(4,NREFL)=1
      KI(N)=1
      IF(NREFL.EQ.1) GO TO 1015
      I=NREFL-1
 1012 IF(NDX(4,I).NE.0) GO TO 1013
      I=I-1
      GO TO 1012
 1013 IF(NDX(5,I).NE.NDX(5,NREFL)) GO TO 1015
      L=NDX(4,I)+1
      NDX(4,I)=L
      NDX(4,NREFL)=0
      S=(FLOAT(L-1)*P(I+K15)+P(N))/FLOAT(L)
      DO 1014 J = 1,L
      K=N+1-J
 1014 P(K)=S
      KI(N)=0
 1015 M=M+KI(N)
      KEYREF(NREFL)=M
 1016 CONTINUE
      NV=M
C      GOTO 1019
      NPM=NP-1
      MS=NV
      MV=1
      MZ=1
      DO 1019 I = 1,NPM
      IF(I.LE.KEYSUM) GO TO 1018
      IF(I.LE.K15) GO TO 1019
      IF(KI(I).EQ.0) GO TO 1019
      NREFL=I-K15
      N=NDX(5,NREFL)
      NREFLP=NREFL+1
      MZT=MZ
      MST=MS
      K=0
      DO 1017 M = NREFLP,NPEAKS
      IF(NDX(4,M).EQ.0) GO TO 1017
      K=K+1
      L=NDX(5,M)-N
      IF(L.GT.NSIDE) GO TO 1018
      MW=MV+K
      MZT=MZT+MST
      MST=MST-1
      MZP=MZ+K
      AM(MZ )=AM(MZ )+SLACK(L)
      AM(MZP)=AM(MZP)-SLACK(L)
      AM(MZT)=AM(MZT)+SLACK(L)
      DIFF=P(I)*FLOAT(NDX(4,NREFL))-P(I+K)*FLOAT(NDX(4,M))
      V(MV)=V(MV)-DIFF*SLACK(L)
      V(MW)=V(MW)+DIFF*SLACK(L)
 1017 CONTINUE
 1018 MV=MV+1
      MZ=MZ+MS
      MS=MS-1
 1019 CONTINUE
 1020 NM=(NV*(NV+1))/2
      M=NV-KEYSUM
      WRITE(IOO,20) NV,M
C     START LOOP THROUGH OBSERVATIONS
      DO 1039 NREFL = 1,NPEAKS
      H(1)=NDX(1,NREFL)
      H(2)=NDX(2,NREFL)
      H(3)=NDX(3,NREFL)
      SINTHL=SNTL(NREFL)
      SINTH=SINTHL*WAVETC
      POINT=2.0* ASIN(SINTH)/DEGRAD
      COSTH=SQRT(1.0-SINTH**2)
      TANTH=SINTH/COSTH
      UVW=(PWISE(6)*TANTH+PWISE(7))*TANTH+PWISE(8)
      FACTOR=WAVETC/(SINTHL*COSTH*DEGRAD)
      AREA1=SQRT(UVW)
C ADD LORENTZIAN GAMMMA=FWHH
	IF(PWISE(9).LT.0.0) PWISE(9)=0.0001
      GAMSQ=PWISE(9)*(TANTH**2+1)
      GAM=SQRT(GAMSQ)
      SIGMA=AREA1/CONFW
C     LORENTZ CORRECTION, POLARISATION MUST BE ADDED FOR X-RAYS
      CLOR(NREFL)=1./(COSTH*SINTH**2)
      SINS(NREFL)=POINT
      YC=P(NREFL+K15)
 1021 PHICAL=POINT-PWISE(5)-BLOCK
C   IMPROVE ADDRESS OF PEAK POSITION
      PHIT=PHICAL+BLOCK
      ICHE=PHIT/STEP+0.5
      I1=ICHE-10
      I2=ICHE+10
      DO 1142 I0=I1,I2
      MIDREF=I0
      IF(PHIT.LT.WISE(I0,3)) GOTO 1143
 1142 CONTINUE
      WRITE(IOO,47)
      STOP
 1143 MIDREF=MIDREF-NBLOCK
      IF(MIDREF.GT.KTEST) GO TO 1026
      IQUERY=NREFL
      SUS=GAMSQ+UVW
      SUS=SQRT(SUS)
      NWIDTH=3.0*SUS/STEP
      MEANWD=MEANWD+NWIDTH
      IF(NWIDTH.GT.NWIDE) NWIDTH=NWIDE
      NSTART=MIDREF-NWIDTH
      NFINIS=MIDREF+NWIDTH
      IF(NSTART.LT.1) CALL FINISH(2)
      DC(5)=-1.0
      DC(6)= TANTH**2
      DC(7)= TANTH
      DC(8)= 1.0
      DC(9)=TANTH**2+1
      DO 1022 L = 1,6
 1022 DC(L+9)=(DCELL(L,1)*H(1)**2+DCELL(L,4)*H(2)*H(3)
     1        +DCELL(L,2)*H(2)**2+DCELL(L,5)*H(3)*H(1)
     2        +DCELL(L,3)*H(3)**2+DCELL(L,6)*H(1)*H(2))*FACTOR
      IF(LATTIS.LT.8) GO TO 1023
      DC(10)=DC(10)+DC(11)
      IF(LATTIS.LT.12) GO TO 1023
      IF(LATTIS.GT.19) GO TO 1023
      DC(10)=DC(10)+DC(12)
      DC(13)=DC(13)+DC(14)+DC(15)
 1023 DO 1025 NSTEP = NSTART,NFINIS
      IBLOCK=NSTEP+NBLOCK
C   MOD FOR SYNCHROTRON DATA
      MARKP(IBLOCK)=MARKP(IBLOCK)+1
      DELTA=WISE(IBLOCK,3)-(PHICAL+BLOCK)
      XV=DELTA/(SIGMA*SQRTWO)
      YV=GAM/(SIGMA*TWSQTW)
      CALL WERF(REW,RIM,XV,YV)
      VOIGT=REW/(SIGMA*TWPIRT)
      YCPART=YC*VOIGT
      DIFFAC(2)=YC*(REW*XV-RIM*YV)/(SIGMA**2*SQRTPI)
      DIFFAC(3)=YC*(-REW/2+REW*(XV**2-YV**2)-2*RIM*XV*YV+YV/SQRTPI)
     1/(TWPIRT*SIGMA*UVW)
      DIFFAC(1)=YC*(REW*YV**2+RIM*XV*YV-YV/SQRTPI)/
     1(GAMSQ*SIGMA*TWPIRT)
      DIFFAC(6)=VOIGT
      IF(KEY.GT.NV) GO TO 1025
      DO 1024 L = KEY,KEYSUM
      M=LVAR(L)
      K=INDIC(M)
 1024 DWISE(NSTEP,L)=DWISE(NSTEP,L)+DIFFAC(K)*DC(M)
C     INDIC(K)=6 FOR ALL ABOVE P(K15), WHERE PEAKS START
C     PEAK HEIGHT DIFFERENTIALS ARE ALL PWISE(1)
      IF(NV.EQ.KEYSUM) GO TO 1025
      L=NREFL+K15
      IF(KI(L).EQ.0) GO TO 1025
      M=KEYREF(NREFL)
      DWISE(NSTEP,M)=DWISE(NSTEP,M)+DIFFAC(6)
 1025 WISE(IBLOCK,2)=WISE(IBLOCK,2)+YCPART
      IF(IQUERY.LT.NPEAKS) GO TO 1039
C     ADD DIFFERENTIALS FOR BACKGROUND AND SCALE IF REQUIRED AND
C     ADD BLOCK TO LEAST SQUARES MATRIX, SUM DIFFERENCES
 1026 DO 1037 KBLOCK = 1,KBL
      IBLOCK=KBLOCK+NBLOCK
      BACKGD=PWISE(2)
      L=0
      IF(KI(1).EQ.0) GO TO 1027
      L=L+1
      DWISE(KBLOCK,L)=WISE(IBLOCK,2)/PWISE(1)
 1027 IF(KI(2).EQ.0) GO TO 1028
      L=L+1
      DWISE(KBLOCK,L)=1.0
C     PWISE(3) IS DELETED
 1028 WISE(IBLOCK,2)=WISE(IBLOCK,2)+BACKGD+WISE(IBLOCK,4)
      IF(WISE(IBLOCK,1).LT.YMASK) GO TO 1037
      DY=WISE(IBLOCK,1)-WISE(IBLOCK,2)
      ABSDY=ABS (DY)
      RZNUM=RZNUM+ABSDY
      IF(MARKP(IBLOCK).NE.0) THEN
      RPNUM=RPNUM+ABSDY
      RPDEN=RPDEN+WISE(IBLOCK,1)
      ENDIF
      GO TO (1029,1030,1031,1032,5013),IW
 5013 WEIGHT=1.0/WT(IBLOCK)**2
      GO TO 1033
 1029 WEIGHT=1.0
      GO TO 1033
 1030 WEIGHT=1.0/WISE(IBLOCK,1)
      GO TO 1033
 1031 WEIGHT=1.0/(WISE(IBLOCK,1)**2)
      GO TO 1033
 1032 WEIGHT=ABSDY
      GO TO 1033
C     WEIGHT IS THE SQUARE OF ORFLS WEIGHT
C     WDY HAS BEEN REMOVED
 1033 SIG=SIG+WEIGHT*DY**2
      JK=1
      DO 1036 J=1,NV
      TEMP=DWISE(KBLOCK,J)*WEIGHT
      IF(TEMP.NE.0.0)  GO TO 1034
C     BY-PASS IF DERIVATIVE IS ZERO
      JK=JK+NV+1-J
      GO TO 1036
 1034 DO 1035 K=J,NV
      AM(JK)=AM(JK)+TEMP*DWISE(KBLOCK,K)
      JK=JK+1
 1035 CONTINUE
      V(J)=V(J)+TEMP*DY
 1036 JK=JK
 1037 CONTINUE
C     END LOOP TO STORE MATRIX AND VECTOR
C     TRANSFER BLOCK
      DO 1038 L = 1,KBL
      N=L+KBL
      DO 1038 M = 1,NV
      DWISE(L,M)=DWISE(N,M)
 1038 DWISE(N,M)=0.0
      NBLOCK=NBLOCK+KBL
      IF(NBLOCK.GT.NMAX) GO TO 1040
      BLOCK=NBLOCK*STEP
      IF(IQUERY.LT.NPEAKS) GO TO 1021
      IF(IQUERY.GT.NPEAKS) GO TO 1039
      IQUERY=IQUERY+1
      GO TO 1026
 1039 CONTINUE
C     END LOOP THROUGH OBSERVATIONS
 1040 IF(IC.NE.NOUT) GO TO 140
C**** PUNCH OUT OBS AND CALC INTENSITIES IN STANDARD FILE FORMAT
      WRITE(IOP,148),TITLE
	WRITE(IOP,148)TITLE
      WRITE(14,148) TITLE
      IF(LATTIS.EQ.1) ISYST=7
      IF(LATTIS.EQ.2.OR.LATTIS.EQ.3) ISYST=6
      IF(LATTIS.GT.3.AND.LATTIS.LT.8) ISYST=3
      IF(LATTIS.GT.7.AND.LATTIS.LT.12) ISYST=2
      IF(LATTIS.GT.11.AND.LATTIS.LT.18) ISYST=1
      IF(LATTIS.GT.17.AND.LATTIS.LT.20) ISYST=5
      IF(LATTIS.GT.19) ISYST=4
      WRITE(14,948) KEYSUM,NPEAKS,ISYST
  948 FORMAT(3I5)
  148 FORMAT(20A4)
	NBMES=MAXPTU-MINPTU
8000	FORMAT(3F8.3)
8001	FORMAT(I3,I5)
8002	FORMAT(2I5)
8003	FORMAT(8(F7.0,1X))
	WRITE(IOP,8000)PTMAX,PTMIN,STEP
	NPHASE=1
	WRITE(IOP,8001)NPHASE,NBMES
	WRITE(IOP,8002)NPHASE,NPHASE
	WRITE(IOP,8003)(WISE(I,1),I=MINPTU,MAXPTU)
	WRITE(IOP,8003)(WISE(I,2),I=MINPTU,MAXPTU)
C	TYPE *,PTMAX,PTMIN,STEP,MAXPTU,MINPTU
C      DO141II=MINPTU,MAXPTU,10
C          IIP9=II+9
C          I1=0
C          DO146I=II,IIP9
C              I1=I1+1
C              DO146J=1,2
C  146             INTENS(I1,J+1)=WISE(I,J)
C      I1=0
C      DO 147 I=II,IIP9
C      I1=I1+1
C  147 INTENS(I1,1)=WISE(I,3)*10000
C	TYPE 149,INTENS
C        WRITE(IOP,149) INTENS
C141	CONTINUE
  149 FORMAT(10(I8))
C**** END OF MOD TO PUNCH OUT INTENSITIES, A.HEWAT MAY'82
      IF(IC.EQ.NOUT) CALL PLOTLP
  140 IF(IC.EQ.-NOUT) CALL PLOTLP
C     COMPUTE AND PUT OUT AGREEMENT FACTORS
      SQSIG=SQRT (ABS (SIG/FLOAT (NO-NV)))
      MEANWD=MEANWD/NPEAKS
      NEWNO=NO/MEANWD
      IF(NEWNO.EQ.NV)NEWNO=NEWNO+1
      SQSNY=SQRT (ABS (SIG/FLOAT (NEWNO-NV)))
      WRITE(IOO,37) MEANWD,NEWNO,SQSNY
      SQSNY=SQSNY/SQSIG
      WRITE(IOO,26) IC,SIG,SQSIG
      CALL SETWT(IOO,SLACK,SIG,REFSIG,NO)
      RZ=RZNUM/YSUM
      WRITE(IOO,21)
      WRITE(IOO,22) RZNUM,YSUM,RZ
      RP=RPNUM/RPDEN
      WRITE(IOO,21)
      WRITE(IOO,45) RPNUM,RPDEN,RP
C     START LOOP TO TEST FOR ZERO DIAGONAL ELEMENT
      ISING=0
      II=1
      IID=NV
      DO 1042 I=1,NV
      IF(AM(II).NE.0.0)  GO TO 1041
      ISING=1
      WRITE(IOO,28)  I
 1041 II=II+IID
      IID=IID-1
 1042 CONTINUE
C     END LOOP TO TEST FOR ZERO DIAGONAL ELEMENT
C     TERMINATE JOB IF ZERO DIAGONAL ELEMENT WAS FOUND
      IF(ISING.NE.0)  CALL FINISH(11)
C     ENTER SUBROUTINE TO REPLACE MATRIX WITH INVERSE
      CALL MATINV(NV,ISING)
      IF(ISING.NE.0) CALL FINISH(10)
C     START LOOP FOR MATRIX VECTOR MULTIPLICATION FOR PARAMETER CHANGES
      DO 1045 I=1,NV
      PDI=0.0
      IJ=I
      IJD=NV-1
      DO 1044 J=1,NV
      PDI=PDI+AM(IJ)*V(J)
      IF(J.GE.I)  GO TO 1043
      IJ=IJ+IJD
      IJD=IJD-1
      GO TO 1044
 1043 IJ=IJ+1
 1044 CONTINUE
      DC(I)=PDI
      SIG=SIG-PDI*V(I)
 1045 CONTINUE
C     END LOOP FOR MATRIX VECTOR MULTIPLICATION
C     RECOMPUTE AGREEMENT FACTOR USING MODIFIED SIG
      SQSIG=SQRT (ABS (SIG/FLOAT (NO-NV)))
C     PUT OUT CAPTION FOR LIST OF CORRECTED PARAMETERS
      WRITE(IOO,29) IC
C     START LOOP TO CORRECT AND PUT OUT PARAMETERS
      J=1
      II=1
      IJ=NV
      L=1
      NS=1
      DO 1049 I=1,NP
      NREFL=I-K15
      IF(KI(I).EQ.0) GO TO 1048
      IF(I.GT.K15) L=NDX(4,NREFL)
      FL=L
      POLD=P(I)
      PDI=DC(J)
      P(I)=POLD+PDI/FL
C
C  CONTROL OF NEGATIVE INTENSITIES
C
      IF(I.GT.K15.AND.P(I).LT.0.0) P(I)=1.0
      DC(J)=AM(II)
      II=II+IJ
      IJ=IJ-1
      SIGP=SQRT(DC(J))*SQSIG
      SIGNEW=SIGP*SQSNY
      SIGRAT=PDI/SIGP
      J=J+1
      IF(I.LE.K15) GO TO 1047
C     DISTRIBUTE THE INTENSITY BETWEEN CLOSE REFLECTIONS
      M=I+L-1
      DO 1046 N = I,M
 1046 P(N)=P(I)
      WRITE(IOO,19) (NDX(K,NREFL),K=1,5),I,POLD,PDI,P(I),SIGP,
     1               SIGRAT,SIGNEW,SINS(NREFL),CLOR(NREFL)
C**** PUNCH OUT HKL LIST AND INTENSITIES AS IN PROF2 IF NOUT>0
      IF(IC.NE.NOUT) GO TO 1049
      TTHETA=2.0*ASIN(SNTL(NREFL)*WAVETC)/DEGRAD
      WRITE(14,1099) (NDX(K,NREFL),K=1,4),TTHETA,P(I),SIGP
 1099 FORMAT(1X,3I4,3X,I3,F8.3,2F10.2)
C  SEARCH IDX LIST FOR CORRECT MULTIPLICITY
  150 DO152N=NS,NBG
          DO151K=1,3
  151         IF(IDX(K,N).NE.NDX(K,NREFL)) GO TO 152
          FMULT=IDX(4,N)
          NS=NS+1
          GO TO 153
  152     CONTINUE
      IF(NS.EQ.1) GO TO 154
      NS=1
      GO TO 150
  154 WRITE(IOO,159) (NDX(K,NREFL),K=1,3)
  159 FORMAT(' ****WARNING**** UNABLE TO FIND MULTIPLICITY OF ',3I5)
  153 PQPQ=ABS(P(I))
      IF(PQPQ.LT.0.00001) PQPQ=0.00001
      DIVI=FMULT*CLOR(NREFL)
      IF(DIVI.LE.0.000001) DIVI=1
       FF=1.5*SQRT(PQPQ/DIVI)
C###### FIX THE ABOVE EXPRESSION FOR FF ##########
      SIGFF=0.5*FF*SIGP/PQPQ
      IF(P(I).LT.0.) FF=0.0000001
      IF(SIGFF.GT.99.) SIGFF=99.
      WRITE(IOF,1089) (NDX(K,NREFL),K=1,3),FF,SIGFF
C#### 1089 FORMAT(3I8,8X,F8.4)
 1089 FORMAT(3I4,2F8.2)
C****  1089 IS FORMAT FOR SHELX SYSTEM. A.H. JUNE'82
      WRITE(IOX,1069) (NDX(K,NREFL),K=1,3),FF,SIGFF
 1069 FORMAT('HKL    XXX   ',3I3,'     1  1',F9.4,9X,F9.4)
C  1069 IS FORMAT FOR XRYATS SYSTEM. A.H. JUNE'82
C**** END OF MOD TO PUNCH OUT HKL LIST. A.HEWAT JUNE'82
      GO TO 1049
 1047 WRITE(IOO,30) I,POLD,PDI,P(I),SIGP,SIGRAT,SIGNEW
      IF(IC.NE.NOUT) GO TO 1049
        PIII=P(I)
        SPIII=SIGP
         IF(I.EQ.13.OR.I.EQ.14.OR.I.EQ.15) THEN
           PIII=PIII/DEGRAD
           SPIII=SPIII/DEGRAD
         END IF
	WRITE(14,5714) I,PIII,SPIII
 5714	FORMAT(I5,2F12.5)
      GO TO 1049
 1048 IF(I.LE.K15) WRITE(IOO,18) I,P(I)
      IF(I.LE.K15.AND.IC.EQ.NOUT.AND.I.GT.4) THEN 
        IF(I.LT.13) WRITE(14,5714) I,P(I)
            IF(I.EQ.13.OR.I.EQ.14.OR.I.EQ.15) THEN
                PIII=P(I)/DEGRAD
                WRITE(14,5714) I,PIII
            END IF
      END IF
      IF(I.GT.K15) WRITE(IOO,17) (NDX(K,NREFL),K=1,5),I,P(I)
      IF(IC.NE.NOUT.OR.I.LE.K15) GO TO 1049
      WRITE(14,1099) (NDX(K,NREFL),K=1,4),TTHETA,P(I),SIGP
 1049 CONTINUE
      IF(LATTIS.LT.8) GO TO 1050
      P(11)=P(10)
      IF(LATTIS.LT.12) GO TO 1050
      IF(LATTIS.GT.19) GO TO 1050
      P(12)=P(10)
      P(14)=P(13)
      P(15)=P(13)
C     END LOOP TO CORRECT AND PUT OUT PARAMETERS
C     PUT OUT ESTIMATED AGREEMENT FACTORS
 1050 WRITE(IOO,27) IC,SIG,SQSIG
C     ENTER SUBROUTINE TO TEST PARAMETERS
      ISTOP=0
      CALL TEST
      IF(ISTOP.NE.0) CALL FINISH(9)
 1051 CONTINUE
        WRITE(14,949) VCELL
  949   FORMAT(F10.2)
	WRITE(14,22) RZ
	WRITE(14,45) RP
C     END LOOP THROUGH NC CYCLES AND FINAL CALC OF Y
C     TERMINATE JOB
C     WRITE LAST BIT ONTO NEW INPUT
      WRITE(ION,60) RCP
   60 FORMAT(3F8.4,3F8.3)
      WRITE(ION,62) (P(I),I=1,9)
   62 FORMAT(6F12.7,/,3F12.7)
      WRITE(ION,64) LATTIS,(ISCREW(I),I=1,3),(IGLIDE(I),I=1,3)
   64 FORMAT(7I3)
	DO I=16,NP
	J=I-K15
	WRITE(ION,5702)(NDX(K,J),K=1,3),P(I)
	END DO
 5702	FORMAT(3I3,F10.1)
C
C  NOT OUTPUT OF FLAG'S IN THE UNIT=9
C
C      DO 1079 I=1,IVAR
C 1079 WRITE(ION,66) (KVAR(I,J),J=1,K15)
C   66 FORMAT(15I1)
      IF(NC.EQ.0)  GO TO 1056
C**** CALCULATE AND PUT OUT CORRELATION MATRIX IF KOUT > 1.
      IF(KOUT.LT.2) GO TO 1056
      WRITE(IOO,31)
      DO 1052 I=1,NV
      DC(I)=1.0/SQRT(DC(I))
 1052 CONTINUE
      IJ=1
      DO 1055 I=1,NV
      IF(I.NE.1)  V(I-1)=10000.0
      DO 1053 J=I,NV
      V(J)=0.0
 1053 CONTINUE
      DO 1054 J=I,NV
      V(J)=AM(IJ)*DC(I)*DC(J)
      IJ=IJ+1
 1054 CONTINUE
      K=1+10*((I-1)/10)
      WRITE(IOO,32) I,(V(J),J=K,NV)
 1055 IJ=IJ
 1056 CALL FINISH(12)
      END
      SUBROUTINE SETWT(IOO,SLACK,SIG,REFSIG,NO)
      DIMENSION SLACK(10)
   19 FORMAT('   NEW SLACK ARE NOW    ',4F12.2/6F12.2)
      IF(SIG.EQ.0) GO TO 1092
      W=SIG/(FLOAT(NO)*REFSIG**2)
      DO 1091 I = 1,10
      SLACK(I)=W
 1091 W=W*0.5
      GO TO 1094
 1092 DO 1093 I = 1,10
 1093 SLACK(I)=0.0
 1094 WRITE(IOO,19) SLACK
      RETURN
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE PRELIM(ITYPE)
      COMMON IOI,IOO,AM(51360),V(321),DEGRAD,RCP(6),DCELL(6,6),AT(3,3),
     1 ZT(3,3),IRHOMB,LATTIS,MINRH,MAXRH,NPEAKS,NBG,NDX(5,515),STEP,
     2 WISE(14100,4),MINPT,MAXPT,PTMIN,PTMAX,RMAX,ISCREW(3),IGLIDE(3),
     3 NREFS,IC,NC,NV,NVM,NP,NM,ISTOP,KEY,NREFL,TWOPIS,KEYREF(515),
     4 P(515),KI(515),PWISE(9),H(3),RHO,NOUT,NPM,MINPTU,MAXPTU,
     5 TWOPI,YC,WAVETC,DC(515),YSUM,YMASK,YAV,NMAX,NEXT,NSIDE,IW,
     6 KEYSUM,MSTEPU,SNTL(515),IDX(5,1500),LVAR(321),NO,KOUT,
     7 SLACK(10),SIG,REFSIG,LOT,K15,NPK,IVAR,KVAR(13,15),
     8 ION,MARKP(14100),YOBS(8600),WT(8600)
      DOUBLE PRECISION FIL1,FIL2
      DIMENSION MDX(3),TEX(20)
      DIMENSION IIN(10),WISAN(10),WISEIN(10)
      DIMENSION RBG(200),BG(200),SW(8600)
   40 FORMAT(' VALUE OF SIG USED FOR INITIAL SLACK IS',F12.0/' REFLECTIO
     1N DIFFERENCE FOR SLACK IS',F12.4,/' SUBORDINATION RANGE IS',I4/)
   41 FORMAT(' CELL IS',3F8.4,3F8.3)
   42 FORMAT(24I3)
   43 FORMAT(8F9.3)
   44 FORMAT(3(F11.6,2I2))
   45 FORMAT(//I10,' = NUMBER OF REFLECTIONS'/I10,' = NUMBER OF PARAMETE
     1RS READ')
   46 FORMAT(10F8.0)
   47 FORMAT(3I3,F12.2)
   48 FORMAT(I10,' = NUMBER OF OBSERVED POINTS'/F10.0,' = TOTAL COUNTS'/
     1F10.3,' = AVERAGE COUNT'/E11.3,' STATISTICAL SIG'/)
   49 FORMAT(' REFLECTION INTENSITIES TO BE VARIED'/(I4,2I3,F12.2))
   51 FORMAT(A10)
   52 FORMAT(' BACKGROUND AND DATA ARE FROM UNITS: 41 AND 42')
   53 FORMAT(' U ARE ONLY ALLOWED 13 CYCLES MAXIMUM')
   54 FORMAT(2F12.0)
   55 FORMAT(' ** WARNING: BACKGROUND TABLE NOT INCREASING IN ANGLE ',
     1' ******')
   56 FORMAT(' TWO POINTS WITH SAME ANGLE IN BACKGROUND TABLE'/
     1' FIRST IS CHOSEN *********************')

      READ(IOI,*)  NC,NOUT,KOUT,IW,IRHOMB,NSIDE
      WRITE(IOO,42) NC,NOUT,KOUT,IW,IRHOMB,NSIDE
      WRITE(ION,42) NC,NOUT,KOUT,IW,IRHOMB,NSIDE
C     WRITE(ION,42) NC,NOUT,KOUT,IW,IRHOMB,LOT,NSIDE
      IF(NC.GT.13) THEN
      WRITE(IOO,53)
      STOP
      END IF
      READ(IOI,*)  SIG,REFSIG
      WRITE(ION,54) SIG,REFSIG
C     SET UP TRANSFORMATION TO ORTHOGONAL AXES
      READ(IOI,*)  (RCP(I),I=1,6)
      WRITE(IOO,41) (RCP(I),I=1,6)
      CALL CELLAZ
      READ(IOI,*)  (PWISE(I),I=1,9)
C     INPUT OF REFLECTIONS AND SCAN
      READ(IOI,*) LATTIS,(ISCREW(I),I=1,3),(IGLIDE(I),I=1,3)
      IF(MINPT.EQ.0) CALL FINISH(13)
C**** IF BACKGROUND <OR=0, READ IN BACKGROUND VALUES UNTIL '-100'
C     USE B/G = -B/G OR USE AVERAGE B/G AS STARTING VALUE FOR PARAMETER

      OPEN(UNIT=41,STATUS='OLD',FORM='FORMATTED')
      OPEN(UNIT=42,STATUS='OLD',FORM='FORMATTED')
      WRITE(IOO,1209)
 1209 FORMAT(' BACKGROUND CO-ORDINATES')
      RBG(1)=0.1
      I=1
 1200 I=I+1
 1227 READ(41,*,END=1201) RBG(I),BG(I)
      IF(RBG(I).EQ.RBG(I-1)) THEN
      WRITE(IOO,56)
      GOTO 1227
      ENDIF
      IF(RBG(I).LT.RBG(I-1)) THEN
      WRITE(IOO,55)
      STOP
      ENDIF
      WRITE(IOO,1199) RBG(I),BG(I)
 1199 FORMAT(F8.3,F8.0)
      GO TO 1200
 1201 I=I-1
      IF(I.LE.1) GO TO 1100
      RBG(1)=1
      BG(1)=BG(2)
      RBG(I+1)=179.9
      BG(I+1)=BG(I)
      GO TO 1100
 1203 CONTINUE
C**** END OF MOD TO READ IN BACKGROUND. A.HEWAT JUNE'82
C     REFGEN DOES NOT ALTER THE NUMBER OF REFLECTIONS FITTED
 1100 CALL REFGEN
      WRITE(IOO,49)
      IF(NPEAKS) 1102,1102,1101
 1101 READ(IOI,*)  ((NDX(I,J),I=1,3),P(J+K15),J=1,NPEAKS)
      WRITE(IOO,47) ((NDX(I,J),I=1,3),P(J+K15),J=1,NPEAKS)
      DO 1111 J = 1,NPEAKS
      P(J+K15)=P(J+K15)*PWISE(1)
 1111 NDX(4,J)=1
      GO TO 1110
C**** IF NPEAK=0, OR NPEAK<0, USE GENERATED REFLEXIONS AS PARAMETERS
C     NOTE: IF NPEAK=0, ONLY B/G SHOULD BE REFINED ON 1ST CYCLE
C            IE PARAMETER CODE SHOULD BE 010000000000000
      DATA NPK/0/
 1102 NPKS=NBG
      IF(NPKS.GT.NPM-K15) NPKS=NPM-K15
      NPK=0
      DO1104J=1,NPKS
          IF(IDX(5,J).GT.IFIX(0.94*FLOAT(MAXRH))) GO TO 1104
          NPK=NPK+1
          DO1103I=1,3
 1103         NDX(I,NPK)=IDX(I,J)
          P(NPK+K15)=0.
 1104     CONTINUE
C  IF NPEAKS IS -VE, READ IN AND REPLACE -NPEAKS INTENSITIES
      IF(NPEAKS.EQ.0) GO TO 1109
      NPEAKS=-NPEAKS
      DO1107K=1,NPEAKS
          READ(IOI,*) (MDX(I),I=1,3),PIN
          WRITE(IOO,47) (MDX(I),I=1,3),PIN
C  INSERT THIS INTENSITY INTO LIST NDX IN CORRECT PLACE
          DO1107J=1,NPK
              DO1106 I=1,3
 1106             IF(NDX(I,J).NE.MDX(I)) GO TO 1107
                  P(J+K15)=PIN*PWISE(1)
                  NDX(4,J)=1
 1107         CONTINUE
 1109 IF(NPK.GT.NPEAKS) NPEAKS=NPK
      WRITE(IOO,47) ((NDX(I,J),I=1,3),P(J+K15),J=1,NPEAKS)
C**** END OF MOD BY A.HEWAT, 24-MAY-82
 1110 PWISE(1)=1.0
      NP=NPEAKS+K15
      WRITE(IOO,45) NPEAKS,NP
      DO 1112 I = 1,NMAX
 1112 WISE(I,1)=YMASK-1.
C**** READ IN PROFILE AND NO!!!!! CORRECT TO FLAT BACKGROUND
      II=MINPT-1
	IF(ITYPE.NE.0) GOTO 5015
      READ(42,1194) TEX
      WRITE(IOO,1194) TEX
 1194 FORMAT(20A4)
 1300 READ(42,46,END=1304) (WISAN(I),I=1,10)
      IF(WISAN(1).LT.0.) GO TO 1304
      READ(42,46,END=1304) (WISEIN(I),I=1,10)
      J=1
      DO1303I=1,10
          II=II+1
      WISE(II,3)=WISAN(I)/10000.
 1301     IF(WISE(II,3).GE.RBG(J).AND.WISE(II,3).LE.RBG(J+1)) GO TO 1302
          J=J+1
	GOTO 1301
 1302 WISE(II,4)=BG(J)+(BG(J+1)-BG(J))*(WISE(II,3)-RBG(J))/
     1(RBG(J+1)-RBG(J))
	WISE(II,1)=WISEIN(I)
 1303     IF(WISE(II,1).LE.0) WISE(II,1)=YMASK-1.
      IF(MAXPT.GT.0.AND.II.GE.MAXPT) GO TO 1305
      GO TO 1300
 1304 MAXPT=II
C**** END OF MOD TO CORRECT TO FLAT BACKGROUND. A.HEWAT JUNE'82
C   MODIFICATIONS TO READ FROM DIFFERENT FORMATS. J.RODRIGUEZ OCT-86
 1305 CONTINUE
	GOTO 5016
 5015 CALL INPUT(ITYPE,NPTS,THMIN,SW)
	J=1
	L=0
	DO I=MINPT,MAXPT
	L=L+1
	IF(L.GT.NPTS) GOTO 5310
	WISE(I,1)=YOBS(L)
	WT(I)=SW(L)
	WISE(I,3)=THMIN+(L-1)*STEP
 5301     IF(WISE(I,3).GE.RBG(J).AND.WISE(I,3).LE.RBG(J+1)) GO TO 5302
          J=J+1
	GOTO 5301
 5302 WISE(I,4)=BG(J)+(BG(J+1)-BG(J))*(WISE(I,3)-RBG(J))/
     1(RBG(J+1)-RBG(J))
	END DO
	GOTO 5016
 5310	MAXPT=I
C END OF MODIFICATIONS TO READ FROM DIFF. FORMATS
C FIND FAKED STEP TO GET PRINT AND OTHER THINGS CORRECT
 5016 DO 1651 I1=MAXPT,1,-1
      ANGG=WISE(I1,3)
      IX=I1
      IF(ANGG.NE.0) GOTO 1652
 1651 CONTINUE
 1652 I7=IX-MINPT-1
      STEPP=(ANGG-WISE(MINPT,3))/I7
      WRITE(IOO,85) STEP,STEPP
   85 FORMAT(//' **** OLD AND NEW STEP (FAKED):',2F8.5)
      STEP=STEPP
      DO 1113 I = MINPTU,MAXPTU
      J=I*MSTEPU
 1113 WISE(I,1)=WISE(J,1)
      J=MAXPTU+1
      DO 1114 I = J,MAXPT
 1114 WISE(I,1)=YMASK-1.
      YSUM=0.0
      YSIG=0.0
      NO=0
      DO 1115 I = MINPTU,MAXPTU
      IF(WISE(I,1).LE.0) WISE(I,1)=YMASK-1.
      IF(WISE(I,1).LT.YMASK) GO TO 1115
      NO=NO+1
      YSUM=YSUM+WISE(I,1)
      YSIG=YSIG+SQRT(WISE(I,1))
 1115 CONTINUE
      YAV=YSUM/NO
      WRITE(IOO,48) NO,YSUM,YAV,YSIG
      IF(MAXPTU.GT.NMAX) CALL FINISH(7)
      IF(SIG.EQ.0.0) SIG=YSIG
      WRITE(IOO,40) SIG,REFSIG,NSIDE
      CALL SETWT(IOO,SLACK,SIG,REFSIG,NO)
      IC=0
      CALL TEST
      RETURN
      END
      SUBROUTINE REFGEN
      COMMON IOI,IOO,AM(51360),V(321),DEGRAD,RCP(6),DCELL(6,6),AT(3,3),
     1 ZT(3,3),IRHOMB,LATTIS,MINRH,MAXRH,NPEAKS,NBG,NDX(5,515),STEP,
     2 WISE(14100,4),MINPT,MAXPT,PTMIN,PTMAX,RMAX,ISCREW(3),IGLIDE(3),
     3 NREFS,IC,NC,NV,NVM,NP,NM,ISTOP,KEY,NREFL,TWOPIS,KEYREF(515),
     4 P(515),KI(515),PWISE(9),H(3),RHO,NOUT,NPM,MINPTU,MAXPTU,
     5 TWOPI,YC,WAVETC,DC(515),YSUM,YMASK,YAV,NMAX,NEXT,NSIDE,IW,
     6 KEYSUM,MSTEPU,SNTL(515),IDX(5,1500),LVAR(321),NO,KOUT,
     7 SLACK(10),SIG,REFSIG,LOT,K15,NPK,IVAR,KVAR(13,15),
     8 ION,MARKP(14100),YOBS(8600),WT(8600)
C SEE PAGE 32 OF INTERNATIONAL TABLES, VOLUME 1
C  LATT = 0  1  2  3  4  5            PROGRAM DEDUCES 'LATT'
C         P  R  C  F  I  H  LATTICE
C VALUE FOR R AND H LATTICES DEPENDS ON POINT GROUP
C LAUE GROUP    LATTIS NUMBERS
C               P    C    F    I    LATTICES
C -1            1
C 2/M  Y UNIQUE 2    3
C MMM           4    5    6    7
C 4/M           8              9
C 4/MMM         10             11
C M3            12        13   14
C M3M           15        16   17
C  RHOMB 18 R-3  R3  R-3C
C  RHOMB 19 R32  R3M  R3C  R-3M
C -3    HEX 20
C -3M   HEX 21
C 6/M   HEX 22
C 6/MMM HEX 23
C SCREW AND GLIDE ABSENCES REMOVED, ORTHORHOMBIC AND MONOCLINIC
C BY SETTING THE MULTIPLICITY TO ZERO
C ISCREW(I) =0 : NO SCREW AXIS
C ISCREW(I) =I : 2 FOLD SCREW AXIS ALONG AXIS I
C IGLIDE(I) =0 : NO GLIDE PLANE PERPENDICULAR TO AXIS I
C  "        =1 : A GLIDE PERPENDICULAR TO AXIS I
C  "        =2 : B GLIDE PERPENDICULAR TO AXIS I
C  "        =3 : C GLIDE PERPENDICULAR TO AXIS I
C  "        =4 : N GLIDE PERPENDICULAR TO AXIS I
   51 FORMAT(//I5,' REFLECTIONS GENERATED IN REFGEN'/' LATTICE TYPE',I4)
   52 FORMAT(' 2-FOLD SCREW AXIS ALONG AXIS',I2)
   53 FORMAT(' GLIDE PLANE PERPENDICULAR TO AXIS',I2,' ALONG AXIS',I2)
   54 FORMAT(' N GLIDE PERPENDICULAR TO AXIS',I2)
   55 FORMAT(' MAXIMUM HKL = ',I4)
   56 FORMAT(I5,2I4,I5,I7)
      DO 1201 I=1,NREFS
      DO 1201 J=1,5
 1201 IDX(J,I)=0
      RCPMAX=0.0
      DO 1203 I = 1,3
      IF(ISCREW(I).EQ.I) WRITE(IOO,52) I
      DO 1202 J = 1,3
      IF(IGLIDE(I).EQ.J) WRITE(IOO,53) I,J
 1202 CONTINUE
      IF(IGLIDE(I).EQ.4) WRITE(IOO,54) I
      IF(RCP(I).GT.RCPMAX) RCPMAX=RCP(I)
 1203 CONTINUE
      LIMHKL=2.0*(RCPMAX*RMAX+1.5)
      WRITE(IOO,55) LIMHKL
      LATT=0
      LAUE=0
      NBG=1
      IF(LATTIS.GT.11) GO TO 1215
      IF(LATTIS.LT.8 ) LATT=LATTIS-3
      IF(LATTIS.LT.5 ) LATT=0
      IF(LATTIS.EQ.3 ) LATT=2
      IF(LATTIS.EQ.9 ) LATT=4
      IF(LATTIS.EQ.11) LATT=4
      DO 1209 IL = 1,LIMHKL
      I=IL
      CALL SETHKL(LATT,I,0,0,2)
      CALL SETHKL(LATT,0,I,0,2)
      CALL SETHKL(LATT,0,0,I,2)
      DO 1209 JL = 1,LIMHKL
      J=JL
      IF(LATTIS.EQ.1) GO TO 1204
      CALL SETHKL(LATT,I,J,0,4)
      CALL SETHKL(LATT,0,I,J,4)
      IF(LATTIS.GT.3) GO TO 1205
 1204 CALL SETHKL(LATT,I,0, J,2)
      CALL SETHKL(LATT,I,0,-J,2)
      IF(LATTIS.NE.1) GO TO 1206
      CALL SETHKL(LATT,I, J, 0,2)
      CALL SETHKL(LATT,I,-J, 0,2)
      CALL SETHKL(LATT,0, I, J,2)
      J=JL
      CALL SETHKL(LATT,0, I,-J,2)
      GO TO 1206
 1205 CALL SETHKL(LATT,I,0,J,4)
 1206 DO 1209 KL = 1,LIMHKL
      K=KL
      IF(LATTIS.LT.4) GO TO 1207
      CALL SETHKL(LATT,I,J,K,8)
      GO TO 1209
 1207 IF(LATTIS.EQ.1) GO TO 1208
      CALL SETHKL(LATT,I,J, K,4)
      CALL SETHKL(LATT,I,J,-K,4)
      GO TO 1209
 1208 CALL SETHKL(LATT,I, J, K,2)
      CALL SETHKL(LATT,I, J,-K,2)
      CALL SETHKL(LATT,I,-J, K,2)
      CALL SETHKL(LATT,I,-J,-K,2)
 1209 CONTINUE
      IF(LATTIS.LT.8) GO TO 1226
C ORTHORHOMBIC, MONOCLINIC AND TRICLINIC DONE ........
      IF(LATTIS.LT.10) GO TO 1212
      DO 1210 IL = 2,NBG
      I=IL
      IF(IDX(4,I).NE.8) GO TO 1210
      IF(IDX(1,I).GT.IDX(2,I)) IDX(4,I)=16
      IF(IDX(1,I).LT.IDX(2,I)) IDX(4,I)=0
 1210 CONTINUE
      DO 1211 IL = 2,NBG
      I=IL
      IF(IDX(4,I).NE.4) GO TO 1211
      IF(IDX(3,I).NE.0) GO TO 1211
      IF(IDX(1,I).GT.IDX(2,I)) IDX(4,I)=8
      IF(IDX(1,I).LT.IDX(2,I)) IDX(4,I)=0
 1211 CONTINUE
C 4/MMM TETRAG. PART DONE ........
C 4/M AND 4/MMM TO FINISH ........
 1212 DO 1213 IL = 2,NBG
      I=IL
      IF(IDX(4,I).NE.2) GO TO 1213
      IF(IDX(1,I).NE.0) IDX(4,I)=4
      IF(IDX(2,I).NE.0) IDX(4,I)=0
 1213 CONTINUE
      DO 1214 IL = 2,NBG
      I=IL
      IF(IDX(4,I).NE.4) GO TO 1214
      IF(IDX(3,I).EQ.0) GO TO 1214
      IDX(4,I)=8
      IF(IDX(2,I).EQ.0) IDX(4,I)=0
 1214 CONTINUE
      GO TO 1226
C TETRAGONAL DONE ........
 1215 IF(LATTIS.GT.17) GO TO 1217
      IF(LATTIS.NE.12) LATT=LATTIS-10
      IF(LATTIS.GT.15) LATT=LATTIS-13
      IF(LATTIS.LT.15) LAUE=1
      DO 1216 IL = 1,LIMHKL
      I=IL
      CALL SETHKL(LATT,I,0,0,6)
      CALL SETHKL(LATT,I,I,0,12)
      CALL SETHKL(LATT,I,I,I,8)
      L=I+1
      DO 1216 JL = L,LIMHKL
      J=JL
      IF(LAUE.EQ.0) CALL SETHKL(LATT,I,J,0,24)
      IF(LAUE.EQ.1) CALL SETHKL(LATT,I,J,0,12)
      IF(LAUE.EQ.1) CALL SETHKL(LATT,J,I,0,12)
      CALL SETHKL(LATT,I,I,J,24)
      CALL SETHKL(LATT,J,J,I,24)
      M=J+1
      DO 1216 KL = M,LIMHKL
      K=KL
      IF(LAUE.EQ.0) CALL SETHKL(LATT,I,J,K,48)
      IF(LAUE.EQ.1) CALL SETHKL(LATT,I,J,K,24)
      IF(LAUE.EQ.1) CALL SETHKL(LATT,K,J,I,24)
 1216 CONTINUE
      GO TO 1226
C CUBIC DONE ........
 1217 IF(LATTIS.GT.19) GO TO 1221
      N=12
      IF(LATTIS.EQ.18) N=6
      DO 1220 IL = 1,LIMHKL
      I=IL
      CALL SETHKL(0,I,0,0,6)
      CALL SETHKL(0,I,I,0,6)
      CALL SETHKL(0,I,-I,0,6)
      CALL SETHKL(0,I,I,I,2)
      CALL SETHKL(0,I,I,-I,6)
      L=I+1
      DO 1220 JL = L,LIMHKL
      J=JL
      CALL SETHKL(0,J,I,I,6)
      CALL SETHKL(0,-J,I,I,6)
      CALL SETHKL(0,J,J,I,6)
      CALL SETHKL(0,J,J,-I,6)
      IF(N.EQ.12) GO TO 1218
      CALL SETHKL(0,J,I,0,6)
      CALL SETHKL(0,-J,I,0,6)
      CALL SETHKL(0,-I,I,J,6)
      CALL SETHKL(0,-J,J,I,6)
 1218 CALL SETHKL(0,I,J,0,N)
      CALL SETHKL(0,I,-J,0,N)
      CALL SETHKL(0,I,-I,J,N)
      CALL SETHKL(0,J,-J,I,N)
      M=J+1
      DO 1220 KL = M,LIMHKL
      K=KL
      IF(N.EQ.12) GO TO 1219
      CALL SETHKL(0,J,K,I,6)
      CALL SETHKL(0,J,K,-I,6)
      CALL SETHKL(0,-J,K,I,6)
      CALL SETHKL(0,J,-K,I,6)
 1219 CALL SETHKL(0,K,J,I,N)
      CALL SETHKL(0,K,J,-I,N)
      CALL SETHKL(0,K,-J,I,N)
 1220 CALL SETHKL(0,-K,J,I,N)
      GO TO 1226
C RHOMBOHEDRAL DONE ........
 1221 N=0
      IF(LATTIS.LT.22) N=5
      M=0
      IF(LATTIS.EQ.20) M=5
      IF(LATTIS.EQ.20) LAUE=1
      IF(LATTIS.EQ.22) LAUE=1
      DO 1225 IL = 1,LIMHKL
      I=IL
      L=I+1
      CALL SETHKL(0,I,0,0,6)
      CALL SETHKL(0,I,I,0,6)
      CALL SETHKL(0,0,0,I,2)
      DO 1223 KL = 1,LIMHKL
      K=KL
      CALL SETHKL(M,I,I,K,12)
      CALL SETHKL(N,I,0,K,12)
      DO 1223  JL = L,LIMHKL
      IF(LAUE.EQ.0) GO TO 1222
      CALL SETHKL(N,I,J,K,12)
      CALL SETHKL(N,J,I,K,12)
      GO TO 1223
 1222 CALL SETHKL(N,I,J,K,24)
 1223 CONTINUE
      DO 1225 JL = 1,LIMHKL
      J=JL
      IF(LAUE.EQ.0) GO TO 1224
      CALL SETHKL(0,I,J,0,6)
      CALL SETHKL(0,J,I,0,6)
      GO TO 1225
 1224 CALL SETHKL(0,I,J,0,12)
 1225 CONTINUE
C HEXAGONAL LATTICES DONE ........
C REMOVE SCREW AND GLIDE ABSENCES ........
 1226 IF(NBG.EQ.NREFS) NREFS=-1
      DO 1230 L = 1,3
      M=L+1
      IF(M.EQ.4) M=1
      N=6-L-M
      J=ISCREW(L)
      K=IGLIDE(L)
      IF(J.EQ.0) GO TO 1228
      DO 1227 I = 2,NBG
      IF(IDX(M,I).NE.0.OR.IDX(N,I).NE.0) GO TO 1227
      IPAR=IDX(L,I)
      IF(MOD(IPAR,2).NE.0) IDX(4,I)=0
 1227 CONTINUE
 1228 IF(K.EQ.0) GO TO 1230
      DO 1229 I = 2,NBG
      IF(IDX(L,I).NE.0) GO TO 1229
      IPAR=IDX(K,I)
      IF(K.EQ.4) IPAR=IDX(M,I)+IDX(N,I)
      IF(MOD(IPAR,2).NE.0) IDX(4,I)=0
 1229 CONTINUE
 1230 CONTINUE
C REMOVE THE ZERO MULTIPLICITIES ........
      N=1
      DO 1232 I = 2,NBG
      IF(IDX(4,I).EQ.0) GO TO 1232
      N=N+1
      DO 1231 K = 1,5
 1231 IDX(K,N)=IDX(K,I)
 1232 CONTINUE
C SORT ON INCREASING RHO ........
      NBG=N-1
      DO 1234 I = 1,NBG
      L=I+1
      IRHO=MAXRH
      DO 1233 J = L,N
      IF(IDX(5,J).GT.IRHO) GO TO 1233
      IRHO=IDX(5,J)
      M=J
 1233 CONTINUE
      DO 1234 K = 1,5
      IDX(K,I)=IDX(K,M)
 1234 IDX(K,M)=IDX(K,L)
      WRITE(IOO,51) NBG,LATTIS
      IF(KOUT.GE.1) WRITE(IOO,56) ((IDX(K,I),K=1,5),I=1,NBG)
      IF(KOUT.GE.2) WRITE(KOUT,89) ((IDX(K,I),K=1,3),I=1,NBG)
   89 FORMAT(3I3,'   0.0')
      RETURN
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE SETHKL(LATT,I,J,K,M)
      COMMON IOI,IOO,AM(51360),V(321),DEGRAD,RCP(6),DCELL(6,6),AT(3,3),
     1 ZT(3,3),IRHOMB,LATTIS,MINRH,MAXRH,NPEAKS,NBG,NDX(5,515),STEP,
     2 WISE(14100,4),MINPT,MAXPT,PTMIN,PTMAX,RMAX,ISCREW(3),IGLIDE(3),
     3 NREFS,IC,NC,NV,NVM,NP,NM,ISTOP,KEY,NREFL,TWOPIS,KEYREF(515),
     4 P(515),KI(515),PWISE(9),H(3),RHO,NOUT,NPM,MINPTU,MAXPTU,
     5 TWOPI,YC,WAVETC,DC(515),YSUM,YMASK,YAV,NMAX,NEXT,NSIDE,IW,
     6 KEYSUM,MSTEPU,SNTL(515),IDX(5,1500),LVAR(321),NO,KOUT,
     7 SLACK(10),SIG,REFSIG,LOT,K15,NPK,IVAR,KVAR(13,15),
     8 ION,MARKP(14100),YOBS(8600),WT(8600)
      DIMENSION HJ(3),HK(3)
      IF(NBG.EQ.NREFS) RETURN
      IF(LATT.LT.2) GO TO 1251
      IF(LATT.GT.4) GO TO 1251
      L=I+J
      IF(LATT.EQ.4) L=L+K
      IF(MOD(L,2).NE.0) RETURN
      IF(LATT.NE.3) GO TO 1251
      L=I+K
      IF(MOD(L,2).NE.0) RETURN
 1251 HK(1)=I
      HK(2)=J
      HK(3)=K
      HJ(1)=ZT(1,1)*HK(1)+ZT(2,1)*HK(2)+ZT(3,1)*HK(3)
      HJ(2)=ZT(1,2)*HK(1)+ZT(2,2)*HK(2)+ZT(3,2)*HK(3)
      HJ(3)=ZT(1,3)*HK(1)+ZT(2,3)*HK(2)+ZT(3,3)*HK(3)
      IRHO=2500.*(HJ(1)**2+HJ(2)**2+HJ(3)**2)
      IF(IRHO.GT.MAXRH) RETURN
      IF(IRHO.LT.MINRH) RETURN
      NBG=NBG+1
      IDX(1,NBG)=I
      IDX(2,NBG)=J
      IDX(3,NBG)=K
      IDX(4,NBG)=M
      IDX(5,NBG)=IRHO
      IF(LATT.NE.5) RETURN
      IDX(4,NBG)=M/2
      IF(NBG.EQ.NREFS) RETURN
      NBG=NBG+1
      IDX(1,NBG)=I
      IDX(2,NBG)=J
      IDX(3,NBG)=-K
      IDX(4,NBG)=M/2
      IDX(5,NBG)=IRHO
      RETURN
      END
      SUBROUTINE TEST
      COMMON IOI,IOO,AM(51360),V(321),DEGRAD,RCP(6),DCELL(6,6),AT(3,3),
     1 ZT(3,3),IRHOMB,LATTIS,MINRH,MAXRH,NPEAKS,NBG,NDX(5,515),STEP,
     2 WISE(14100,4),MINPT,MAXPT,PTMIN,PTMAX,RMAX,ISCREW(3),IGLIDE(3),
     3 NREFS,IC,NC,NV,NVM,NP,NM,ISTOP,KEY,NREFL,TWOPIS,KEYREF(515),
     4 P(515),KI(515),PWISE(9),H(3),RHO,NOUT,NPM,MINPTU,MAXPTU,
     5 TWOPI,YC,WAVETC,DC(515),YSUM,YMASK,YAV,NMAX,NEXT,NSIDE,IW,
     6 KEYSUM,MSTEPU,SNTL(515),IDX(5,1500),LVAR(321),NO,KOUT,
     7 SLACK(10),SIG,REFSIG,LOT,K15,NPK,IVAR,KVAR(13,15),
     8 ION,MARKP(14100),YOBS(8600),WT(8600)
      COMMON/VOLUM/VCELL
      DIMENSION KIS(15)
   61 FORMAT(72I1)
   62 FORMAT(' TEMPERATURE FACTOR OF ATOM'I3' ISNT POSITIVE-DEFINITE')
   63 FORMAT(2F8.4,2X,3F8.4,2X,3F9.5,2X,6F8.4)
   65 FORMAT(/' KEYS FOR THIS CYCLE',(/21X,36I2))
   66 FORMAT(52X,F13.7)
   68 FORMAT(I8,' PARAMETERS AND THEIR INDICES INPUT FROM LAST CYCLE')
   69 FORMAT(' PARAMETER',I5,' IS ZEROED FROM',F12.6)
      IF(NEXT.NE.0) GO TO 1410
      GO TO 1402
 1400 DO 1401 J = 1,NP
 1401 READ(IOI,66) P(J)
      IC=-1
 1402 NEXT=0
      IF(IC.EQ.NC) GO TO 1407
      NPQ=NP
      IVAR=IVAR+1
      IF(LOT.NE.0) NPQ=K15
      READ(2,61,END=1420) (KI(I),I=1,NPQ)
      DO 1521 I=1,K15
 1521 KVAR(IVAR,I)=KI(I)
C 1422 DO1423I=1,15
C 1423     IF(KI(I).NE.0.OR.KI(I).NE.1) GO TO 1420
C**** IF GENERATED REFLEXION LIST IS USED (WITH ZERO INTENSITIES)
C     WE CANNOT VARY LATTICE CONSTANTS,ZERO POINT ETC.
 1424 IF(NPK.EQ.0.OR.IC.GT.0) GO TO 1428
      DO1425I=1,15
 1425     KI(I)=0
C**** END OF MOD FOR GENERATED HKL LIST. A.HEWAT JUNE'82
 1428 KEY=KI(1)+KI(2)+KI(3)+KI(4)+1
      KEYSUM=0
      DO 1403 J = 1,K15
 1403 KEYSUM=KEYSUM+KI(J)
      IF(NPQ.EQ.K15) GO TO 1405
      M=KEYSUM
C     THE FOLLOWING IS OVERWRITTEN IF LOT IS NON-ZERO
      DO 1404 I = 16,NP
      M=M+KI(I)
 1404 KEYREF(I-K15)=M
C     SET UP LVAR( ) FOR VARIABLES EXCEPT SCALE AND BACKGROUND
 1405 NV=0
      DO 1406 J=1,NPQ
      IF(KI(J).NE.1) GO TO 1406
      NV=NV+1
      LVAR(NV)=J
 1406 CONTINUE
      WRITE(IOO,65)  (KI(I),I=1,NPQ)
 1407 I=NP+1
      IF(IC.EQ.0) GO TO 1410
      DO 1408 J=1,9
      PWISE(J)=P(J)
      IF(J.GT.3) GO TO 1408
      RCP(J  )=P(J+9 )
      RCP(J+3)=P(J+12)/DEGRAD
 1408 CONTINUE
      CALL CELLAZ
      DO 1409 J = K15,NP
C      IF(P(J).GE.0.0) GO TO 1409
C      WRITE(IOO,69) J,P(J)
C      P(J)=0.0
 1409 P(J)=P(J)*PWISE(1)
      PWISE(1)=1.0
 1410 DO 1411 J = 1,9
      P(J)=PWISE(J)
      IF(J.GT.3) GO TO 1411
      P(J+9 )=RCP(J  )
      P(J+12)=RCP(J+3)*DEGRAD
 1411 CONTINUE
      IF(NEXT.NE.0) GO TO 1400
C####REMOVED FROM ORIGINAL PROGRAM      IF(NV.EQ.0) CALL FINISH(1)
      IF(NV.GT.NVM) CALL FINISH(8)
      RETURN
C**** IF NO KEY CODE IS PRESENT, USE STANDARD CODE
      DATA KIS/0,1,0,0,1,1,1,1,1,1,1,1,1,1,1/
 1420 DO1421I=1,15
 1421     KI(I)=KIS(I)
      IF(IC.LE.5) KI(2)=0
      IF(IC.GT.2) GO TO 1427
      DO1426I=6,9
 1426     KI(I)=0.
 1427 IF(LATTIS.LE.1) GO TO 1424
      KI(13)=0
      KI(15)=0
      IF(LATTIS.LE.3) GO TO 1424
      KI(14)=0
      IF(LATTIS.LE.7) GO TO 1424
C######WARNING. CHECK STANDARD KEY CODES FOR OTHER LATTICES ######
      GO TO 1424
C**** END OF MOD TO USE STANDARD KEY CODE. A.HEWAT JUNE'82
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE CELLAZ
      COMMON IOI,IOO,AM(51360),V(321),DEGRAD,RCP(6),DCELL(6,6),AT(3,3),
     1 ZT(3,3),IRHOMB
      COMMON/VOLUM/CELL
      DIMENSION RECIP(6),SN(3),CS(3),RA(3)
   71 FORMAT(//' NEW CELL =',6F12.6/' CELL VOLUME' ,F15.5/' RECIPROCAL C
     1ELL PARAMETERS',6F10.5/' TRANSFORMATIONS'//(3F12.6,9X,3F12.6))
   72 FORMAT(' SPECIAL RHOMBOHEDRAL SECTION')
      IF(IRHOMB.NE.0) GO TO 1503
      DO 1501 I=1,3
      SN(I)=SIN(RCP(I+3)*DEGRAD)
 1501 CS(I)=COS(RCP(I+3)*DEGRAD)
      RA(1)=CS(2)*CS(3)-CS(1)
      RA(2)=CS(3)*CS(1)-CS(2)
      RA(3)=CS(1)*CS(2)-CS(3)
      BIGD=1.-CS(1)**2-CS(2)**2-CS(3)**2+2.*CS(1)*CS(2)*CS(3)
      AROOT=SQRT(BIGD)
      AT(1,1)=RCP(1)
      AT(1,2)=RCP(2)*CS(3)
      AT(1,3)=RCP(3)*CS(2)
      AT(2,1)=0.
      AT(2,2)=RCP(2)*SN(3)
      AT(2,3)=-RCP(3)*RA(1)/SN(3)
      AT(3,1)=0.
      AT(3,2)=0.
      AT(3,3)=RCP(3)*AROOT/SN(3)
      CELL=AT(1,1)*AT(2,2)*AT(3,3)
      ZT(1,1)=1./RCP(1)
      ZT(1,2)=-CS(3)/(RCP(1)*SN(3))
      ZT(1,3)=RA(2)/(RCP(1)*SN(3)*AROOT)
      ZT(2,1)=0.
      ZT(2,2)=1./(RCP(2)*SN(3))
      ZT(2,3)=RA(1)/(RCP(2)*SN(3)*AROOT)
      ZT(3,1)=0.
      ZT(3,2)=0.
      ZT(3,3)=SN(3)/(RCP(3)*AROOT)
      DO 1502 I = 1,3
      L=I+3
      J=I+1
      IF(J.EQ.4) J=1
      K=6-I-J
      RECIP(I)=SN(I)/(RCP(I)*AROOT)
      RECIP(L)= ACOS(RA(I)/(SN(J)*SN(K)))/DEGRAD
      FAC=0.5/BIGD
      DCELL(I,I  )=-FAC*SN(I)**2/RCP(I)**3
      DCELL(I,J  )=0.0
      DCELL(I,K  )=0.0
      DCELL(I,I+3)=0.0
      DCELL(I,J+3)=-FAC*RA(J)/(RCP(K)*RCP(I)**2)
      DCELL(I,K+3)=-FAC*RA(K)/(RCP(J)*RCP(I)**2)
      FAC=FAC*SN(I)/BIGD
      DCELL(L,I  )=FAC*(CS(I)*BIGD+SN(I)**2*RA(I))/RCP(I)**2
      DCELL(L,J  )=FAC*            SN(J)**2*RA(I) /RCP(J)**2
      DCELL(L,K  )=FAC*            SN(K)**2*RA(I) /RCP(K)**2
      DCELL(L,I+3)=FAC*(2.*RA(I)*RA(I)+BIGD      )/(RCP(J)*RCP(K))
      DCELL(L,J+3)=FAC*(2.*RA(I)*RA(J)-BIGD*CS(K))/(RCP(K)*RCP(I))
      DCELL(L,K+3)=FAC*(2.*RA(I)*RA(K)-BIGD*CS(J))/(RCP(I)*RCP(J))
 1502 CONTINUE
      GO TO 1508
C     RHOMBOHEDRAL: SPECIAL CASE
 1503 ROOT2=SQRT(2.0)
      ROOT3=SQRT(3.0)
      AXIS=RCP(1)
      ALFA=RCP(4)*DEGRAD
      PSI= ACOS(1.0/ROOT3)
      DIF= ASIN(2.0*SIN(ALFA*0.5)/ROOT3)
      PHI=PSI-DIF
      PHIP=-COS(ALFA*0.5)/(ROOT3*COS(DIF))
      COSPHI=COS(PHI)
      SINPHI=SIN(PHI)
      BET=AXIS*COSPHI
      GAM=AXIS*SINPHI/ROOT2
      DEL=BET*(BET+GAM)-2.0*GAM**2
      ZDIA=(BET+GAM)/DEL
      ZOFF=-GAM/DEL
      SN(1)=COSPHI
      CS(1)=SINPHI/ROOT2
      SN(2)=-AXIS*SINPHI*PHIP
      CS(2)= AXIS*COSPHI*PHIP/ROOT2
      DO 1504 I = 1,6
      DO 1504 J = 1,6
 1504 DCELL(I,J)=0.0
      DO 1506 I = 1,2
      DELP=(2.0*BET+GAM)*SN(I)+(BET-4.0*GAM)*CS(I)
      ZDIAP=((SN(I)+CS(I))*DEL-(BET+GAM)*DELP)/DEL**2
      ZOFFP=(GAM*DELP-DEL*CS(I))/DEL**2
      DIA=0.5*ZDIA*ZDIAP+ZOFF*ZOFFP
      OFF=ZDIA*ZOFFP+ZOFF*(ZDIAP+ZOFFP)
      K=3*I-2
      DO 1505 J = 1,3
      DCELL(K,J  )=DIA
 1505 DCELL(K,J+3)=OFF
 1506 CONTINUE
      ASTAR=SQRT((BET+GAM)**2+2.0*GAM**2)/DEL
      ALFST=2.0*ATAN((ROOT3*COS(DIF))/1.0)/DEGRAD
      CELL=(BET-GAM)*DEL
      DO 1507 I = 1,3
      RECIP(I  )=ASTAR
      RECIP(I+3)=ALFST
      DO 1507 J = 1,3
      AT(I,J)=GAM
      AT(I,I)=BET
      ZT(I,J)=ZOFF
 1507 ZT(I,I)=ZDIA
      WRITE(IOO,72)
 1508 CONTINUE
      WRITE(IOO,71) (RCP(I),I=1,6),CELL,(RECIP(I),I=1,6),((AT(I,J),J=1,3
     1 ),(ZT(I,J),J=1,3),I=1,3)
      RETURN
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE MATINV (N,NFAIL)
      COMMON IOI,IOO,AM(51360),V(321)
      K=1
      NFAIL=1
      IF(N.LT.1)  GO TO 1615
      IF(N.GT.1)  GO TO 1601
      AM(1)=1.0/AM(1)
      GO TO 1614
 1601 DO 1607 M=1,N
      IMAX=M-1
      DO 1606 L=M,N
      SUMA=0.0
      KLI=L
      KMI=M
      IF(IMAX.EQ.0)  GO TO 1603
      DO 1602 I=1,IMAX
      SUMA=SUMA+AM(KLI)*AM(KMI)
      J=N-I
      KLI=KLI+J
 1602 KMI=KMI+J
 1603 TERM=AM(K)-SUMA
      IF(L.GT.M)  GO TO 1605
      IF(TERM.GT.0.0)  GO TO 1604
      NFAIL=K
      GO TO 1615
 1604 DENOM=SQRT (TERM)
      AM(K)=DENOM
      GO TO 1606
 1605 AM(K)=TERM/DENOM
 1606 K=K+1
 1607 CONTINUE
      AM(1)=1.0/AM(1)
      KDM=1
      DO 1610 L=2,N
      KDM=KDM+N-L+2
      TERM = 1.0/AM(KDM)
      AM(KDM)=TERM
      KMI=0
      KLI=L
      IMAX=L-1
      DO 1609 M=1,IMAX
      K=KLI
      SUMA=0.0
      DO 1608 I=M,IMAX
      II=KMI+I
      SUMA=SUMA-AM(KLI)*AM(II)
 1608 KLI=KLI+N-I
      AM(K)=SUMA*TERM
      J=N-M
      KLI=K+J
 1609 KMI=KMI+J
 1610 CONTINUE
      K=1
      DO 1613 M=1,N
      KLI=K
      DO 1612 L=M,N
      KMI=K
      IMAX=N-L+1
      SUMA=0.0
      DO 1611 I=1,IMAX
      SUMA=SUMA+AM(KLI)*AM(KMI)
      KLI=KLI+1
 1611 KMI=KMI+1
      AM(K)=SUMA
 1612 K=K+1
 1613 CONTINUE
 1614 NFAIL=0
 1615 RETURN
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE FINISH(IWHY)
      COMMON IOI,IOO
      IF(IWHY.NE.12) GO TO 1701
      WRITE(IOO,82)
      STOP
 1701 WRITE(IOO,81) IWHY
      STOP
   81 FORMAT(' STOPPED FOR REASON',I6/24X'1 : NO PARAMETERS TO BE VARIED
     1'/24X'2 : CONTRIBUTION OUTSIDE BLOCK ARRAY, REORDER REFLECTIONS'/2
     24X'3 : WRONG NUMBER OF PARAMETERS'/24X'4 : TOO MANY PARAMETERS'/24
     3X'5 : TOO MANY ATOMS'/24X'6 : TOO MANY REFLECTIONS'/24X'7 : TOO WI
     4DE A SCAN'/24X'8 : TOO MANY VARIABLES'/24X'9 : UNPHYSICAL TEMPERAT
     5URE FACTOR'/23X'10 : SINGULAR LEAST SQUARES MATRIX'/23X'11 : ZERO
     6DIAGONAL MATRIX ELEMENT'/23X'12 : SUCCESSFUL RUN'/23X'13 : MINPT =
     7 0'/23X'14 : INDEXED LINE OUTSIDE SCAN'/)
   82 FORMAT(' SUCCESSFUL RUN')
      END
C
C-----------------------------------------------------------------------
C
      SUBROUTINE PLOTLP
C PLOT PROFILE ON PRINTER
C CALCULATE A NEW BACKGROUND FUNCT.
      COMMON IOI,IOO,AM(51360),V(321),DEGRAD,RCP(6),DCELL(6,6),AT(3,3),
     1 ZT(3,3),IRHOMB,LATTIS,MINRH,MAXRH,NPEAKS,NBG,NDX(5,515),STEP,
     2 WISE(14100,4),MINPT,MAXPT,PTMIN,PTMAX,RMAX,ISCREW(3),IGLIDE(3),
     3 NREFS,IC,NC,NV,NVM,NP,NM,ISTOP,KEY,NREFL,TWOPIS,KEYREF(515),
     4 P(515),KI(515),PWISE(9),H(3),RHO,NOUT,NPM,MINPTU,MAXPTU,
     5 TWOPI,YC,WAVETC,DC(515),YSUM,YMASK,YAV,NMAX,NEXT,NSIDE,IW,
     6 KEYSUM,MSTEPU,SNTL(515),IDX(5,1500),LVAR(321),NO,KOUT,
     7 SLACK(10),SIG,REFSIG,LOT,K15,NPK,IVAR,KVAR(13,15),
     8 ION,MARKP(14100),YOBS(8600),WT(8600)
      DIMENSION LABEL(12),IOUT(121),IDOTS(121),HJ(3),HK(3),INDT(5),
     1 WINK(200),BACK(200),BAS(200)
      DATA ISPACE/1H /,IDOT/1H./,IPLUS/1HX/,ISTAR/1H*/,IOBS/1HO/,IM/1H-/
   10 FORMAT(///' A BACKGROUND FUNCTION HAS BEEN MADE AS'/
     1'   BACKG = (INPUT BACKG) + PWISE(2) + (MEAN OF OBS-CAL)'/
     2' WHERE MEAN OF OBS-CAL = SUM((OBS-CAL)/OBS)/SUM(1/OBS)'/
     3' PWISE(2) IS THE VARIABLE BACKGROUND.'/
     4' THIS IS A WEIGHTED DELTA, WHICH OF COURSE IS AFFECTED BY'
     5/' ERRORS IN THE FIT.'/
     6' A PLOT IS GIVEN WITH BACKG AS *, AND (INPUT BACKG) + PWISE(2)'
     7' AS O'///)
   20 FORMAT(//' VALUES ON THE LEFT ARE ANGLE AND BACKG'//)
   70 FORMAT(F8.2,F8.1)
   80 FORMAT(60X,'-------')
   81 FORMAT(60X,'--CUT--',55X,F7.2)
   91 FORMAT(3X,12I10)
   92 FORMAT(1X,121A1,F7.2)
   93 FORMAT(1X,121A1,3I3)
   94 FORMAT(//'PLOT (BEFORE LAST CYCLE '
     1/' REORDERED REFLECTIONS'/10(I7,2I3))
   95 FORMAT(1X,121A1,F5.0,I5)
      DO 1806 NREFL = 2,NBG
      HK(1)=IDX(1,NREFL)
      HK(2)=IDX(2,NREFL)
      HK(3)=IDX(3,NREFL)
      HJ(1)=ZT(1,1)*HK(1)+ZT(2,1)*HK(2)+ZT(3,1)*HK(3)
      HJ(2)=ZT(1,2)*HK(1)+ZT(2,2)*HK(2)+ZT(3,2)*HK(3)
      HJ(3)=ZT(1,3)*HK(1)+ZT(2,3)*HK(2)+ZT(3,3)*HK(3)
      SINTH=SQRT(0.25*(HJ(1)**2+HJ(2)**2+HJ(3)**2))*WAVETC
      IDX(5,NREFL)=2.0* ASIN(SINTH)/(DEGRAD*STEP)+0.5
C     THIS IS THE SCAN POINT AS AN INTEGER
      INDX=IDX(5,NREFL)
      K=NREFL
      J=0
      DO 1801 I = 1,20
      IF(K.EQ.1) GO TO 1802
      K=K-1
      IF(INDX.GE.IDX(5,K)) GO TO 1802
 1801 J=J+1
 1802 IF(J.EQ.0) GO TO 1806
      DO 1803 I = 1,5
 1803 INDT(I)=IDX(I,NREFL)
      DO 1804 I = 1,J
      K=NREFL-I
      L=K+1
      DO 1804 M = 1,5
 1804 IDX(M,L)=IDX(M,K)
      DO 1805 I = 1,5
 1805 IDX(I,K)=INDT(I)
 1806 CONTINUE
      WRITE(10,94) ((IDX(I,J),I=1,3),J=1,NBG)
      WMAX=0.0
      DO 1807 I = MINPTU,MAXPTU
      IF(WISE(I,1).GT.WMAX) WMAX=WISE(I,1)
      IF(WISE(I,2).GT.WMAX) WMAX=WISE(I,2)
 1807 CONTINUE
      FSCALE=WMAX/116.
      DO 1808 I = 1,12
 1808 LABEL(I)=10.0*FSCALE*FLOAT(I)
      WRITE(10,91) LABEL
      DO 1809 J = 1,121
      IDOTS(J)=ISPACE
      IF(MOD(J,10).EQ.1) IDOTS(J)=IDOT
 1809 CONTINUE
      WRITE(10,92) IDOTS
      IDX(5,NBG+1)=NMAX+1
      L=PWISE(5)/STEP+0.5
      DO 1810 I = 1,NBG
      IFIND=I+L
      IF(IDX(5,IFIND).GE.MINPTU) GO TO 1811
 1810 CONTINUE
 1811 ICOU=-5
      DO 1821 I = MINPTU,MAXPTU
      IF(MARKP(I).EQ.0.AND.ICOU.GT.0) THEN
      ICOU=ICOU+1
      IF(ICOU.GT.2.AND.MARKP(I+1).EQ.0) GOTO 1821
      IF(ICOU.EQ.1) WRITE(10,81) WISE(I,3)
      IF(ICOU.EQ.2) WRITE(10,80)
      IF(ICOU.GT.2) WRITE(10,81) WISE(I,3)
      GOTO 1821
      ENDIF
      ICOU=0
      M=I+L
      DO 1812 J = 2,120
 1812 IOUT(J)=ISPACE
      IOUT(1)=IDOT
      IOUT(121)=IDOT
      IF(MOD(M,50).NE.0) GO TO 1814
      DO 1813 J = 1,121
 1813 IOUT(J)=IDOTS(J)
 1814 MOBS=WISE(I,1)/FSCALE+1.5
      MCAL=WISE(I,2)/FSCALE+1.5
      IREFL=0
 1815 IF(IDX(5,IFIND).GT.M) GO TO 1816
      IREFL=IREFL+1
      IFIND=IFIND+1
      GO TO 1815
 1816 IF(IREFL.EQ.0) GO TO 1818
      IREFL=120-IREFL
      DO 1817 J = IREFL,120
 1817 IOUT(J)=IM
 1818 IF(MOBS.GT.0) IOUT(MOBS)=IOBS
      IF(MCAL.GT.0) IOUT(MCAL)=ISTAR
      IF(MOBS.LT.0) IOUT(2)=IM
      IF(MOBS.LT.0) MOBS=2
      IF(IOUT(MOBS).EQ.ISTAR) IOUT(MOBS)=IPLUS
      IF(IREFL.EQ.0) GO TO 1819
C     PRINTS LAST IDX SET FOR THIS POINT
      IFINDM=IFIND-1
      WRITE(10,93) IOUT,(IDX(J,IFINDM),J=1,3)
      GO TO 1821
 1819 IF(MOD(M,10).EQ.0) GO TO 1820
      WRITE(10,92) IOUT
      GO TO 1821
 1820 R=WISE(I,3)
      WRITE(10,92) IOUT,R
 1821 CONTINUE
      WRITE(10,92) IDOTS
      WRITE(10,91) LABEL
C  CALCULATE NEW BACKGROUND
      OPEN(UNIT=39,STATUS='NEW',FORM='FORMATTED')
      WRITE(10,10)
      NI=0
      SUMAN=0
      SUMB1=0
      SUMB2=0
      SUMW=0
C  SUM IN STEP OF 1.0 DEG
      DEL=1.0
      BACKG=PWISE(2)
      NA=WISE(MINPTU,3)
      TARG=FLOAT(NA)+DEL
      II=1
      DO 500 I=MINPTU,MAXPTU
      ANG=WISE(I,3)
      OBS=WISE(I,1)
      CALC=WISE(I,2)
      BAC1=BACKG+WISE(I,4)
      BAC2=OBS-CALC
      IF(ANG.LT.TARG) GOTO 300
      TARG=TARG+DEL
      BACK(II)=(SUMB1+SUMB2/SUMW)/FLOAT(NI)
      WINK(II)=SUMAN/NI
      BAS(II)=SUMB1/NI
      WRITE(39,70) WINK(II),BACK(II)
      NI=0
      II=II+1
      SUMAN=0
      SUMB1=0
      SUMB2=0
      SUMW=0
  300 NI=NI+1
      SUMAN=SUMAN+ANG
      SUMB1=SUMB1+BAC1
      SUMB2=SUMB2+BAC2/OBS
      SUMW=SUMW+1/OBS
  500 CONTINUE
      BACK(II)=(SUMB1+SUMB2/SUMW)/FLOAT(NI)
      WINK(II)=SUMAN/NI
      BAS(II)=SUMB1/NI
      WRITE(39,70) WINK(II),BACK(II)
C PLOT IT
C      DO 700 I=1,121
C  700 IOUT(I)=IDOT
C      RMAX=0
C      RMIN=1000000
C      DO 720 I=1,II
C      RMAX=MAX(RMAX,BAS(I),BACK(I))
C      RMIN=MIN(RMIN,BAS(I),BACK(I))
C  720 CONTINUE
C      IF(RMIN.LT.0) RMIN=1
C      RMIN=RMIN-2*SQRT(RMIN)
C      IF(RMIN.LE.0) RMIN=1
C      RMAX=RMAX+2*SQRT(RMAX)
C      FSCALE=(RMAX-RMIN)/116.0
C      DO 730 I=1,12
C  730 LABEL(I)=RMIN+10.0*FSCALE*FLOAT(I)
C      WRITE(10,91) LABEL
C      WRITE(10,92) IOUT
C      DO 740 J=2,120
C  740 IOUT(J)=ISPACE
C      IOUT(1)=IDOT
C      IOUT(121)=IDOT
C      DO 800 I=1,II
C      MOBS=(BAS(I)-RMIN)/FSCALE+1.5
C      MCAL=(BACK(I)-RMIN)/FSCALE+1.5
C      IBA=BACK(I)
C      IOUT(MOBS)=IOBS
C      IOUT(MCAL)=ISTAR
C      IF(IOUT(MOBS).EQ.ISTAR) IOUT(MOBS)=IPLUS
C      WRITE(10,95) IOUT,WINK(I),IBA
C      IOUT(MOBS)=ISPACE
C  800 IOUT(MCALC)=ISPACE
C      DO 830 J=2,120
C  830 IOUT(J)=IDOT
C      IOUT(1)=IDOT
C      IOUT(121)=IDOT
C      WRITE(10,92) IOUT
C      WRITE(10,20)
      RETURN
      END
C------------------------------------------------------------------
	SUBROUTINE INPUT(IFORM,NPTS,THMIN,SW)	
      COMMON IOI,IOO,AM(51360),V(321),DEGRAD,RCP(6),DCELL(6,6),AT(3,3),
     1 ZT(3,3),IRHOMB,LATTIS,MINRH,MAXRH,NPEAKS,NBG,NDX(5,515),STEP,
     2 WISE(14100,4),MINPT,MAXPT,PTMIN,PTMAX,RMAX,ISCREW(3),IGLIDE(3),
     3 NREFS,IC,NC,NV,NVM,NP,NM,ISTOP,KEY,NREFL,TWOPIS,KEYREF(515),
     4 P(515),KI(515),PWISE(9),H(3),RHO,NOUT,NPM,MINPTU,MAXPTU,
     5 TWOPI,YC,WAVETC,DC(515),YSUM,YMASK,YAV,NMAX,NEXT,NSIDE,IW,
     6 KEYSUM,MSTEPU,SNTL(515),IDX(5,1500),LVAR(321),NO,KOUT,
     7 SLACK(10),SIG,REFSIG,LOT,K15,NPK,IVAR,KVAR(13,15),
     8 ION,MARKP(14100),YOBS(8600),WT(8600)
	DIMENSION TXT1(20),DATE(20),SW(8600),VOLT(5)
        CHARACTER JDATE*18,NOEXP*10,P1A*72
	GOTO(2022,2051,2031,2061,3000),IFORM
C
C    DATA FROM D1B(ILL) (IFORM=1)  'OLD FORMAT'
C
2022  READ(42,2026)DATE
      READ(42,2026)TXT1
      READ(42,*)I0,NUMOR
      TSA=FLOAT(NUMOR)
      INUM=1
2029  WRITE(14,12)NUMOR,INUM,TSA
      READ(42,2026)TXT1
      READ(42,2026)TXT1
      J=0
      READ(42,2028)A1,(YOBS(J+NO),NO=1,10)
      J=J+10
      DO 2027 I=2,40
      READ(42,2028)AAA,(YOBS(J+NO),NO=1,10)
2027  J=J+10
      YOBS(1)=YOBS(2)
      DO I=1,400
	SW(I)=SQRT(YOBS(I))
      END DO
      YOBS(400)=YOBS(399)
      THMIN=2.0*A1
      STEP=0.2
      NPTS=400
      THMAX=THMIN+399*STEP
2026  FORMAT(20A4)
2028  FORMAT(F7.3,10F6.0)
      GOTO 484
C
C    DATA FROM D1A(ILL) (IFORM=2)  'OLD FORMAT'
C
2051  READ(42,*,END=99998)THMIN,STEP,THMAX
      NPTS=(THMAX-THMIN)/STEP+1.5
      READ(42,472,END=99998)(SW(I),YOBS(I),I=1,NPTS)
      DO 2025 I=1,NPTS
      IF(YOBS(I).LE.0.00001) YOBS(I)=1.0
      IF(SW(I).LE.0.00001) SW(I)=1.0
2025  SW(I)=1.0/SQRT(SW(I)/YOBS(I))
 472  FORMAT(10(F2.0,F6.0))
      GOTO 484
C
C   DATA FROM N.L.S. (BROOKHAVEN) SYNCHROTRON RADIATION (IFORM=3)
C
2031  READ(42,*,END=99998)THMIN,STEP,THMAX
      NPTS=(THMAX-THMIN)/STEP+1.5
      NLINES=NPTS/10+1
      J=0
      DO 2032 I=1,NLINES
      READ(42,2035,END=99998)(YOBS(J+NO),NO=1,10)
      READ(42,2033,END=99998)(SW(J+NO),NO=1,10)
      J=J+10
2032  CONTINUE
      DO 2034 I=2,NPTS
      IF(SW(I).EQ.0.) SW(I)=SW(I-1)
      IF(YOBS(I).EQ.0.) YOBS(I)=YOBS(I-1)
2034  CONTINUE
2035  FORMAT(10F8.0)
2033  FORMAT(10F8.1)
      GOTO 484
2061	READ(42,*)THMIN,STEP,THMAX
	NPTS=(THMAX-THMIN)/STEP+1.5
	READ(42,*) (YOBS(I),I=1,NPTS)
	DO I=1,NPTS
	SW(I)=SQRT(YOBS(I))
	END DO 
        GOTO 484
3000  READ(42,1)NSET
   1    format(i5)
 	READ(42,2)jdate,noexp,p1a
   2	format(1x,a,2x,a,2x,a)
	READ(42,3)nset1,numor,NSUMAD
   3    format(i3,1x,i6,1X,I4)
      READ(42,4)xmon,tim,X0,omega,chi,phi,tr1,tr2,step,tset,tcons,tsamp
   4    format(f13.0,f9.0,1x,10(f8.3,1x))
        THMIN=X0
	READ(42,5)NPTS,(volt(nv),nv=1,5),numc1,numc2
   5    format(i4,1x,5(f9.3,1x),29x,i6,3x,i6)
        WRITE(14,12)NUMOR,NSUMAD,TSAMP
  12    FORMAT(I6,1X,I4,1X,F12.3)
	j=0
        NPUNT2=NPTS/10
        THMAX=THMIN+(NPTS-1)*STEP
 	do i=1,NPUNT2
	READ(42,6)(SW(j+no),YOBS(j+no),no=1,10)
	j=j+10
	end do
   6    format(10(F2.0,F8.0))
        READ(42,7)inum
   7    format(i10)
        DO I=1,NPTS
        IF(YOBS(I).LE.0.00001) YOBS(I)=1.0
        SW(I)=1.0/SQRT(SW(I)/YOBS(I))
        END DO
 484	RETURN
99998	STOP 'END OF DATA IN UNIT 42: INTENSITY DATA FILE '	
	END
      subroutine werf(rs1,rs2,xx,yy)
c   calculates the complex error function. rs1:real part
c   rs2: imaginary part.
c
c   From W.F.David 
c
c   see J. Appl. Cryst. 18 (1985) 461
c   and Batty, Hoath and Roberts Nucl. Inst. Meth. 137 (1976) 179
c
c   xx and yy are real and imaginary part of z
c
      implicit real*8  (a-h,o-z)
      real*8           lambda
      logical          b
      x=dabs(xx)
      y=dabs(yy)
      if(y.lt.4.29.and.x.lt.5.33) goto 1
      h=0.0
      nc=0
      nu=8
      lambda=0.0
      b=.true.  
      goto 2
    1 s=(1.0-y/4.29)*dsqrt(1.0-x**2/28.41)
      h=1.6*s
      h2=2.0*h
      nc=6+idint(23.0*s)
      nu=9+idint(21.0*s)
      lambda=h2**nc
      b=.false.
      if(lambda.eq.0.0) b=.true.
    2 r1=0.0
      r2=0.0
      s1=0.0
      s2=0.0
      n=nu+1
    3 n=n-1
      fn=n+1
      t1=y+h+fn*r1
      t2=x-fn*r2
      c=0.5/(t1**2+t2**2)
      r1=c*t1
      r2=c*t2
      if(h.le.0.0.or.n.gt.nc) goto 4
      t1=lambda+s1
      s1=r1*t1-r2*s2
      s2=r2*t1+r1*s2
      lambda=lambda/h2
    4 if(n.gt.0) goto 3
      if(b) goto 6
      rs1=s1
      rs2=s2
      goto 7
    6 rs1=r1
      rs2=r2
    7 rs1=1.12837916709551*rs1
      if(y.eq.0.0) rs1=dexp(x**2)
      rs2=1.12837916709551*rs2
      if(xx.lt.0.0) rs2=-rs2
      return
      end
